// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function (modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      var res = localRequire.resolve(x);
      return res === false ? {} : newRequire(res);
    }

    function resolve(x) {
      var id = modules[name][1][x];
      return id != null ? id : x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [
      function (require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function () {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function () {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"6snCa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _connection = require("./Connection");
var _eventPool = require("./EventPool");
var _eventPoolDefault = parcelHelpers.interopDefault(_eventPool);
var _eventTarget = require("./EventTarget");
var _eventTargetDefault = parcelHelpers.interopDefault(_eventTarget);
var _peer = require("./Peer");
var _peerDefault = parcelHelpers.interopDefault(_peer);
var _room = require("./Room");
var _roomDefault = parcelHelpers.interopDefault(_room);
var _wstsprotocol = require("./WSTSProtocol");
var _wstsprotocolDefault = parcelHelpers.interopDefault(_wstsprotocol);
class MWSE extends (0, _eventTargetDefault.default) {
    rooms = new Map();
    pairs = new Map();
    peers = new Map();
    constructor(options){
        super();
        this.server = new (0, _connection.Connection)(options);
        this.server.connect();
        this.WSTSProtocol = new (0, _wstsprotocolDefault.default)(this);
        this.EventPooling = new (0, _eventPoolDefault.default)(this);
        this.me = new (0, _peerDefault.default)(this);
        this.me.scope(()=>{
            this.peers.set("me", this.me);
            this.peers.set(this.me.socketId, this.me);
        });
        this.server.onActive(async ()=>{
            this.me.setSocketId("me");
            await this.me.metadata();
            this.emit("scope");
            this.activeScope = true;
        });
        this.packMessagingSystem();
    }
    packMessagingSystem() {
        this.EventPooling.signal("pack", (payload)=>{
            let { to , pack  } = payload;
            this.peer(to).emit("message", pack);
        });
        this.EventPooling.signal("pack/room", (payload)=>{
            let { to , pack  } = payload;
            this.room(to).emit("message", pack);
        });
    }
    room(options) {
        if (typeof options == "string") {
            if (this.rooms.has(options)) return this.rooms.get(options);
            if (this.rooms.has(options)) return this.rooms.get(options);
        }
        let room = new (0, _roomDefault.default)(this);
        room.setRoomOptions(options);
        this.emit("room");
        return room;
    }
    peer(options) {
        if (typeof options == "string") {
            if (this.peers.has(options)) return this.peers.get(options);
            if (this.pairs.has(options)) return this.pairs.get(options);
        }
        let peer = new (0, _peerDefault.default)(this);
        peer.setPeerOptions(options);
        this.emit("peer", peer);
        return peer;
    }
}
exports.default = MWSE;
window.MWSE = MWSE;

},{"./Connection":"dzYK1","./EventPool":"37Faq","./Peer":"bVhKw","./Room":"7qlv2","./WSTSProtocol":"3kvWC","@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE","./EventTarget":"lleyn"}],"dzYK1":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Connection", ()=>Connection);
class Connection {
    autoPair = false;
    connected = false;
    constructor(options){
        this.endpoint = new URL(options.endpoint);
        this.autoPair = options.autoPair || false;
    }
    connect() {
        this.ws = new WebSocket(this.endpoint.href);
        this.addWSEvents();
    }
    disconnect() {
        this.ws.close();
    }
    addWSEvents() {
        this.ws.addEventListener("open", ()=>this.eventOpen());
        this.ws.addEventListener("close", ()=>this.eventClose());
        this.ws.addEventListener("error", ()=>this.eventError());
        this.ws.addEventListener("message", ({ data  })=>this.eventMessage(data));
    }
    eventOpen() {
        this.connected = true;
        for (const callback of this.activeConnectionEvent)callback(void 0);
    }
    eventClose() {
        this.connected = false;
    }
    eventError() {
        this.connected = false;
    }
    recaivePackEvent = [];
    onRecaivePack(func) {
        this.recaivePackEvent.push(func);
    }
    activeConnectionEvent = [];
    onActive(func) {
        if (this.connected) func();
        else this.activeConnectionEvent.push(func);
    }
    eventMessage(data) {
        if (typeof data == "string") {
            let $data = JSON.parse(data);
            for (const callback of this.recaivePackEvent)callback($data);
        }
    }
    tranferToServer(data) {
        if (this.connected) this.ws.send(JSON.stringify(data));
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE"}],"i1YYE":[function(require,module,exports) {
exports.interopDefault = function(a) {
    return a && a.__esModule ? a : {
        default: a
    };
};
exports.defineInteropFlag = function(a) {
    Object.defineProperty(a, "__esModule", {
        value: true
    });
};
exports.exportAll = function(source, dest) {
    Object.keys(source).forEach(function(key) {
        if (key === "default" || key === "__esModule" || dest.hasOwnProperty(key)) return;
        Object.defineProperty(dest, key, {
            enumerable: true,
            get: function() {
                return source[key];
            }
        });
    });
    return dest;
};
exports.export = function(dest, destName, get) {
    Object.defineProperty(dest, destName, {
        enumerable: true,
        get: get
    });
};

},{}],"37Faq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
class EventPool {
    events = new Map();
    signals = new Map();
    count = 0;
    constructor(wsts){
        this.wsts = wsts;
    }
    request(msg) {
        return new Promise((ok, rej)=>{
            let id = ++this.count;
            this.wsts.WSTSProtocol.SendRequest(msg, id);
            this.events.set(id, [
                (data)=>{
                    ok(data);
                },
                (data)=>{
                    rej(data);
                }
            ]);
        });
    }
    stream(msg, callback) {
        let id = ++this.count;
        this.wsts.WSTSProtocol.StartStream(msg, id);
        this.events.set(id, [
            (data)=>{
                callback(data);
            },
            ()=>{}
        ]);
    }
    signal(event, callback) {
        let T = this.signals.get(event);
        if (!T) this.signals.set(event, [
            callback
        ]);
        else T.push(callback);
    }
}
exports.default = EventPool;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE"}],"bVhKw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _eventTarget = require("./EventTarget");
var _eventTargetDefault = parcelHelpers.interopDefault(_eventTarget);
class Peer extends (0, _eventTargetDefault.default) {
    selfSocket = false;
    active = false;
    constructor(wsts){
        super();
        this.mwse = wsts;
    }
    setPeerOptions(options) {
        if (typeof options == "string") this.setSocketId(options);
        else this.options = options;
    }
    setSocketId(uuid) {
        this.socketId = uuid;
    }
    async metadata() {
        if (this.socketId == "me") {
            let result = await this.mwse.EventPooling.request({
                type: "my/socketid"
            });
            this.selfSocket = true;
            this.active ||= true;
            this.socketId = result;
            this.emit("scope");
            this.activeScope = true;
            return result;
        }
    }
    async enablePairAuth() {
        await this.mwse.EventPooling.request({
            type: "auth/pair-system",
            value: "everybody"
        });
    }
    async disablePairAuth() {
        await this.mwse.EventPooling.request({
            type: "auth/pair-system",
            value: "disable"
        });
    }
    async send(pack) {
        await this.mwse.EventPooling.request({
            type: "pack/to",
            pack,
            to: this.socketId
        });
    }
}
exports.default = Peer;

},{"./EventTarget":"lleyn","@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE"}],"lleyn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
class EventTarget {
    events = {};
    emit(eventName, ...args) {
        if (this.events[eventName]) for (const callback of this.events[eventName])callback(...args);
    }
    on(eventName, callback) {
        if (this.events[eventName]) this.events[eventName].push(callback);
        else this.events[eventName] = [
            callback
        ];
    }
    activeScope = false;
    scope(f) {
        if (this.activeScope) f();
        else this.on("scope", f);
    }
}
exports.default = EventTarget;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE"}],"7qlv2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _eventTarget = require("./EventTarget");
var _eventTargetDefault = parcelHelpers.interopDefault(_eventTarget);
class Room extends (0, _eventTargetDefault.default) {
    constructor(wsts){
        super();
        this.mwse = wsts;
    }
    setRoomOptions(options) {
        if (typeof options == "string") this.roomId = options;
        else this.options = options;
    }
    setRoomId(uuid) {
        this.roomId = uuid;
    }
    async createRoom(roomOptions) {
        let options = this.options || roomOptions;
        let result = await this.mwse.EventPooling.request({
            type: "create-room",
            ...options
        });
        if (result.status == "fail") {
            if (result.message == "ALREADY-EXISTS") return this.join();
            throw new Error(result.message || result.messages);
        } else {
            this.options = {
                ...this.options,
                ...result.room
            };
            this.roomId = result.room.id;
        }
    }
    async join() {
        let result = await this.mwse.EventPooling.request({
            type: "joinroom",
            name: this.options.name,
            credential: this.options.credential
        });
        if (result.status == "fail") throw new Error(result.message);
        else {
            this.options = {
                ...this.options,
                ...result.room
            };
            this.roomId = result.room.id;
        }
    }
    async send(pack, wom = false) {
        await this.mwse.EventPooling.request({
            type: "pack/room",
            pack,
            to: this.roomId,
            wom
        });
    }
}
exports.default = Room;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE","./EventTarget":"lleyn"}],"3kvWC":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
class WSTSProtocol {
    constructor(wsts){
        this.mwse = wsts;
        this.addListener();
    }
    addListener() {
        this.mwse.server?.onRecaivePack((pack)=>{
            this.PackAnalyze(pack);
        });
    }
    SendRaw(pack) {
        this.mwse.server.tranferToServer(pack);
    }
    SendOnly(pack) {
        this.mwse.server.tranferToServer([
            pack,
            "R"
        ]);
    }
    SendRequest(pack, id) {
        this.mwse.server.tranferToServer([
            pack,
            id,
            "R"
        ]);
    }
    StartStream(pack, id) {
        this.mwse.server.tranferToServer([
            pack,
            id,
            "S"
        ]);
    }
    PackAnalyze(data) {
        let [payload, id, action] = data;
        if (typeof id === "number") {
            let callback = this.mwse.EventPooling.events.get(id);
            if (callback) {
                callback[0](payload, action);
                switch(action){
                    case "E":
                        this.mwse.EventPooling.events.delete(id);
                        break;
                    case "S":
                    default:
                        break;
                }
            } else console.warn("Missing event sended from server");
        } else {
            let signals = this.mwse.EventPooling.signals.get(id);
            if (signals) for (const callback1 of signals)callback1(payload);
            else console.warn("Missing event sended from server");
        }
    }
}
exports.default = WSTSProtocol;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"i1YYE"}]},["6snCa"], "6snCa", "parcelRequiref9d4")

//# sourceMappingURL=index.js.map
